<template>
  <v-data-table
    :headers="headers"
    :items="dispData"
    :items-per-page="30"
    dense
    class="elevation-1"
  >
    <template v-slot:top>
      <v-toolbar flat dense short>
        <v-toolbar-title>整備</v-toolbar-title>
        <v-divider class="mx-4" inset vertical />
        <v-spacer />
        <v-switch label="縮小表示" class="mx-4" v-model="min" />
        <v-dialog v-model="dialog">
          <template v-slot:activator="{ on, attrs }">
            <v-btn color="primary" small v-bind="attrs" v-on="on">
              新規
            </v-btn>
          </template>
          <v-card>
            <v-card-text>
              <v-container>
                <v-row>
                  <inline-date-picker
                    title="整備日"
                    v-model="editedItem.mainteDate"
                    dense
                  />
                  <v-text-field
                    v-model.number="editedItem.odo"
                    :rules="odoRules"
                    label="走行距離"
                    required
                    type="number"
                    dense
                  />
                  <v-combobox
                    v-model="editedItem.category"
                    :items="selects.categories"
                    label="カテゴリ"
                    dense
                  />
                  <v-text-field
                    v-model="editedItem.subject"
                    :rules="subjectRules"
                    label="整備項目"
                    required
                    dense
                  />
                  <v-text-field
                    v-model.number="editedItem.cost"
                    :rules="costRules"
                    label="費用"
                    dense
                  />
                  <v-combobox
                    v-model="editedItem.shop"
                    :items="selects.shops"
                    label="ショップ"
                    dense
                  />
                  <v-text-field v-model="editedItem.memo" label="メモ" dense />
                </v-row>
              </v-container>
            </v-card-text>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="blue darken-1" text @click="close"> Cancel </v-btn>
              <v-btn color="blue darken-1" text @click="save"> Save </v-btn>
            </v-card-actions>
          </v-card>
        </v-dialog>
        <v-dialog v-model="dialogDelete" max-width="500px">
          <v-card>
            <v-card-title class="text-h5">削除しますか？</v-card-title>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="blue darken-1" text @click="closeDelete"
                >Cancel</v-btn
              >
              <v-btn color="blue darken-1" text @click="deleteItemConfirm"
                >OK</v-btn
              >
              <v-spacer></v-spacer>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </v-toolbar>
    </template>
    <template v-slot:[`item.actions`]="{ item }">
      <v-icon small class="mr-2" @click="editItem(item)"> mdi-pencil </v-icon>
      <v-icon small @click="deleteItem(item)"> mdi-delete </v-icon>
    </template>
  </v-data-table>
</template>

<script>
import InlineDatePicker from '~/components/InlineDatePicker.vue';
export default {
  components: { InlineDatePicker },

  mounted: function () {
    if (localStorage.getItem('mainteData')) {
      try {
        this.mainteData = JSON.parse(localStorage.getItem('mainteData'));
      } catch (e) {
        localStorage.removeItem('mainteData');
      }
    }
  },

  data: () => ({
    min: true,
    dialog: false,
    dialogDelete: false,
    selects: {
      categories: ['機関系', '駆動系', 'シャシ', '電気系', 'その他'],
      shops: ['モノタロウ', 'ディーラー', 'その他'],
    },
    mainteData: [],
    editedIndex: -1,
    editedItem: {
      mainteDate: new Date(Date.now() - new Date().getTimezoneOffset() * 60000)
        .toISOString()
        .substr(0, 10),
      odo: '',
      category: '',
      subject: '',
      cost: '',
      shop: '',
      memo: '',
    },
    defaultItem: {
      mainteDate: new Date(Date.now() - new Date().getTimezoneOffset() * 60000)
        .toISOString()
        .substr(0, 10),
      odo: '',
      category: '',
      subject: '',
      cost: '',
      shop: '',
      memo: '',
    },
    odoRules: [(v) => !!v || '走行距離は必須です'],
    subjectRules: [(v) => !!v || '整備項目は必須です'],
    costRules: [(v) => /^[0-9]*$/.test(v) || '金額は整数です'],
  }),

  computed: {
    dispData() {
      let disp = [];
      this.mainteData.forEach((item, idx) => {
        if (this.min) {
          disp.push({
            //mainteDate: item['mainteDate'],
            odo: item['odo'],
            subject: item['subject'],
          });
        } else {
          disp.push({
            mainteDate: item['mainteDate'],
            odo: item['odo'],
            category: item['category'],
            subject: item['subject'],
            cost: item['cost'],
            shop: item['shop'],
            memo: item['memo'],
            index: idx,
          });
        }
      });
      return disp.reverse();
    },
    headers() {
      if (this.min) {
        return [
          //{ text: '整備日', value: 'mainteDate', sortable:false },
          { text: '走行距離', value: 'odo', sortable:false },
          { text: '整備項目', value: 'subject', sortable:false },
        ];
      } else {
        return [
          { text: '整備日', value: 'mainteDate' },
          { text: '走行距離', value: 'odo' },
          { text: 'カテゴリ', value: 'category' },
          { text: '整備項目', value: 'subject' },
          { text: '費用', value: 'cost' },
          { text: 'ショップ', value: 'shop' },
          { text: 'メモ', value: 'memo' },
          { text: '操作', value: 'actions', sortable: false },
        ];
      }
    },
  },

  watch: {
    dialog(val) {
      val || this.close();
    },
    dialogDelete(val) {
      val || this.closeDelete();
    },
  },

  created() {
    this.initialize();
  },

  methods: {
    initialize() {
      this.mainteData = [];
    },

    editItem(item) {
      this.editedIndex = item.index; //this.mainteData.indexOf(item);
      this.editedItem = Object.assign({}, item);
      this.dialog = true;
    },

    deleteItem(item) {
      this.editedIndex = item.index; //this.mainteData.indexOf(item);
      this.editedItem = Object.assign({}, item);
      this.dialogDelete = true;
    },

    deleteItemConfirm() {
      this.mainteData.splice(this.editedIndex, 1);
      const parsed = JSON.stringify(this.mainteData);
      localStorage.setItem('mainteData', parsed);
      this.closeDelete();
    },

    close() {
      this.dialog = false;
      this.$nextTick(() => {
        this.editedItem = Object.assign({}, this.defaultItem);
        this.editedIndex = -1;
      });
    },

    closeDelete() {
      this.dialogDelete = false;
      this.$nextTick(() => {
        this.editedItem = Object.assign({}, this.defaultItem);
        this.editedIndex = -1;
      });
    },

    save() {
      if (this.editedIndex > -1) {
        Object.assign(this.mainteData[this.editedIndex], this.editedItem);
      } else {
        this.mainteData.push(this.editedItem);
      }
      const parsed = JSON.stringify(this.mainteData);
      localStorage.setItem('mainteData', parsed);
      this.close();
    },
  },
};
</script>